var bannerActive = false,
	startTime = new Date(),
	smallScale = 0.9,
	scale = smallScale,
	playingTuba = false,
	scale = 0,
	randomMove = false,
	lastVibr = 0,
	active = true,
	infoPage = false,
	startedPlaying,
	stoppedPlaying,
	msecStopSound = 800; //in ms


$(document).ready(function() {
	console.log("documentready");

	// position tuba
	$("#tuba").css("margin-top", -$("#tuba").height()/2);

	// addEventListeners
	document.addEventListener("deviceready", onDeviceReady, false);
	document.addEventListener("pause", onPause, false);
	document.addEventListener("resume", onResume, false);

	// bind external links
	$(".externallink").click(
		function() {
			navigator.app.loadUrl($(this).attr("link"), { openExternal:true } );
		}
	);

	// bind buttons
	$("#infoBtn").bind("touchend", toggleInfo);
	$("#tuba").bind("touchstart", startTuba);
	$("#tuba").bind("touchend", stopTuba);
	$("#dollarBtn").bind("touchend", playDollars);

	// prevent touchmove
	document.addEventListener("touchmove", function(event) {
		event.preventDefault();
	});

	// start moving tuba
	updateTuba();

});

function onDeviceReady() {
	console.log("ondeviceready");

	// preload sounds
	LowLatencyAudio.preloadAudio('StopTuba', 'sounds/stoptuba.ogg', 1);
	LowLatencyAudio.preloadAudio('PlayTuba', 'sounds/playtuba.ogg', 1);
	LowLatencyAudio.preloadAudio('60Dollars', 'sounds/60dollars.ogg', 1);

	// catch back button (if on infoPage go back to main, else exit)
	document.addEventListener("backbutton", function(){
		if (infoPage) {
			toggleInfo();
		} else {
			navigator.app.exitApp();
		}
	}, false);

	// check if there is internet to show the banner
	bannerActive = (navigator.connection.type != Connection.NONE);

	// // show admob ads
	// if( window.plugins && window.plugins.AdMob ) {
	// 	console.log("starting to add admob ad");
	// 	var admob_ios_key = '';
	// 	var admob_android_key = 'ca-app-pub-9912038831128772/8689904440';
	// 	var adId = (navigator.userAgent.indexOf('Android') >=0) ? admob_android_key : admob_ios_key;
	// 	var am = window.plugins.AdMob;

	// 	alert("3");
	// 	alert(adId);

	// 	setTimeout(function(){am.createBannerView(
	// 		{
	// 			'publisherId': adId,
	// 			'adSize': am.AD_SIZE.BANNER,
	// 			'bannerAtTop': false
	// 		},
	// 		function() {
	// 			console.log("create banner view success");
	// 			am.requestAd(
	// 				{ 'isTesting':false },
	// 				function(){
	// 					console.log("request add success");
	// 					am.showAd( true );
	// 				},
	// 				function(){ console.log('failed to request ad'); }
	// 				);
	// 		},
	// 		function(){ console.log('failed to create banner view'); }
	// 		);
	// 	}, 1000);
	// } else {
	// 	console.log('AdMob plugin not available/ready.');
	// }

	// hide splash screen
	// navigator.splashscreen.hide();
}

function toggleInfo() {
	console.log("toggleInfo");

	// hide/show stuff
	$("#infoBtn").toggleClass("infohidden");
	$("#infoBtn").toggleClass("infovisible");
	$("#dollarBtn").toggle();
	$("#tuba").toggle();
	$("#info").toggle();

	//set infoPage variable
	infoPage = !infoPage;

	// show arrow if on info page and there is a banner
	if (infoPage && bannerActive) {
		showArrow();
	} else {
		$("#arrow-wrapper").hide();
	}

	return false;
}

function onPause() {
	console.log("onPause");
	active = false;
}

function onResume() {
	console.log("onResume");
	active = true;
	requestAnimationFrame(updateTuba);
}

function updateTuba() {
	if (active) { requestAnimationFrame(updateTuba); }

	//  msec counter
	var millis = (new Date() - startTime);

	// move tuba
	$("#tuba").css("transform", "rotate(" + ((randomMove ? 40*(Math.random()-0.5) : playingTuba ? 10 : 5)*Math.sin(millis/(playingTuba ? 150 : 240))-20) + "deg) scale(" + (scale) + ")");

	// if tuba is not playing bring back scale to smallScale
	if (!playingTuba && scale > smallScale) {
		var msecAfterStop = (new Date() - stoppedPlaying);
		scale = 1 - (1-smallScale)*(msecAfterStop/msecStopSound);
		if ((millis - lastVibr) > 100) {
			lastVibr = millis;
			navigator.notification.vibrate(50);
		}
	}

	// if tuba scale <= small scale do not move random
	if (scale <= smallScale) {
		scale = smallScale;
		randomMove = false;
	}

}

function playDollars() {
	LowLatencyAudio.stop("StopTuba");
	LowLatencyAudio.stop("PlayTuba");
	LowLatencyAudio.play("60Dollars");

	return false;
}

function startTuba() {
	console.log("startTuba");

	playingTuba = true;
	startedPlaying = new Date();

	// set to full scale
	scale = 1;

	// stop moving random
	randomMove = false;

	LowLatencyAudio.stop("StopTuba");
	LowLatencyAudio.loop("PlayTuba");
	return false;
}

function stopTuba() {
	console.log("stopTuba");

	playingTuba = false;
	stoppedPlaying = new Date();

	// start moving random
	randomMove = true;

	// show hint if only player for 300 ms
	if ((stoppedPlaying - startedPlaying) < 300) {
		$("#hint").show();
		setTimeout(function(){
			$("#hint").hide();
		},2000);
	}

	LowLatencyAudio.stop("PlayTuba");
	LowLatencyAudio.play("StopTuba");
	return false;
}

function showArrow() {
	var onoffTimes = [600, 700, 1000, 1100, 1250];

	for (var i = 0; i < onoffTimes.length; i++) {
		setTimeout(function(){
			if ($("#infoBtn").hasClass("infovisible")) {
				$("#arrow-wrapper").toggle();
			}
		}, onoffTimes[i]);
	}
}


